package org.jtag.dialog;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.io.*;
import javax.swing.*;

import org.jtag.mp3.*;


public class JTagMp3HeaderDialog extends JDialog {
	
    public JTagMp3HeaderDialog(String title, boolean modal, boolean resize, mp3Info info, JFrame owner) {
        super(owner, title, modal);

        String list[] = {
                "Mpeg version", "Mpeg layer",
                "Protection bit", "Bitrate", "Frequency", "Padding bit",
                "Private bit", "Mode", "Mode extension", 
                "Copyright bit", "Original home",
                "Emphasis", "Playlength (min:sec)", "Playlength (sec)"
            };
  
        // Print filename and directory before all other values
        // so table offset ist 2
        int tableOffset = 2;   	

        //setTitle(title);
        //setModal(modal);
        setResizable(resize);

        setBackground(Color.lightGray);

        JPanel contentPane = (JPanel) getContentPane();
      
        String header[] = new String[2];

        header[0] = "Field";
        header[1] = "Value";
      
        String values[][] = new String[list.length + tableOffset][2];

        values[0][0] = "File";
        values[0][1] = info.fileName;

        values[1][0] = "Directory";
        values[1][1] = info.directoryName;

        // First 8 are only id3 fields
        for (int i = 0; i < list.length; i++) {
            String val = info.getMp3HeaderValue(list[i]);

            values[i + tableOffset][0] = list[i];
            values[i + tableOffset][1] = val;
        }
   	
        // Now add the table
        JTable table = new JTable(values, header);
   	
        JScrollPane scroller = new JScrollPane(table);
   	
        contentPane.add(scroller);
   	 
    }	
   	  
}
