package org.jtag.dialog;

import java.awt.*;
import java.awt.event.*;
import java.util.*;
import java.io.*;
import javax.swing.*;
import javax.swing.border.*;

import org.jtag.table.*;
import org.jtag.dnd.*;


public class JTagPrefs extends JDialog
    implements ActionListener, ItemListener {
    public SourceList list1;
    public TargetList list2;
	
    JTabbedPane mTabbedPane;
    JPanel      mSavePanel;
	
    JPanel      mPlayPanel;
	
    public JTagDatabasePrefs	mDatabasePanel;
	
    public JTagSyncPrefs     mSyncPanel;

    public JRadioButton radioTab,
        radioOtherCharacter;
	
    public JTagTableTextField textSepChar;
    public JTextField         textMp3Player;		
	
    public JButton						 buttonOk,
        buttonCancel;
	
    public Vector list1Data = new Vector();
    public Vector list2Data = new Vector();
	
    public JTagPrefs(String title, boolean modal, boolean resize, Vector vector1, Vector vector2) {
   	  
        setTitle(title);
        setModal(modal);
        setResizable(resize);

        setBackground(Color.lightGray);

        JPanel contentPane = (JPanel) getContentPane();
   	
        mTabbedPane = new JTabbedPane();
        mTabbedPane.setPreferredSize(null);
   	
        mSavePanel = new JPanel();
        mSavePanel.setLayout(null);
		  
        //---- SAVE panel	  
        mTabbedPane.addTab("Save", new ImageIcon("images/save.gif"), mSavePanel);

        contentPane.setLayout(new BorderLayout());

        // Load the source list.

        //list1Data.add( "Source Item 1" );
        //list1Data.add( "Source Item 2" );
        //list1Data.add( "Source Item 3" );
        //list1Data.add( "Source Item 4" );
        //list1Data.add( "Source Item 5" );
   	
        list1Data = vector1;
        list2Data = vector2;
   	
        // Create the source list.

        list1 = new SourceList();
        list1.setListData(list1Data);

        // Place the source list.
        JScrollPane mListScroller1 = new JScrollPane(list1);

        mListScroller1.setBounds(25, 65, 150, 200);
        mSavePanel.add(mListScroller1);
      
        // Create the target list.

        list2 = new TargetList();
        list2.listData = list2Data;
        list2.setListData(list2Data);

        // Place the target list.
        JScrollPane mListScroller2 = new JScrollPane(list2);

        mListScroller2.setBounds(220, 65, 150, 200);
        mSavePanel.add(mListScroller2);
   	
        //JButton buttonDelete = new JButton("Delete");
        JButton buttonDelete = new JButton(new ImageIcon("images/trash.gif"));

        buttonDelete.setMargin(new Insets(0, 0, 0, 0));
        buttonDelete.setBounds(400, 65, 40, 40);
        //JButton buttonUp = new JButton("Up");
        JButton buttonUp = new JButton(new ImageIcon("images/arrow_up.gif"));

        buttonUp.setMargin(new Insets(0, 0, 0, 0));
        buttonUp.setBounds(400, 130, 40, 40);
        //JButton buttonDown = new JButton("Down");
        JButton buttonDown = new JButton(new ImageIcon("images/arrow_down.gif"));

        buttonDown.setMargin(new Insets(0, 0, 0, 0));
        buttonDown.setBounds(400, 180, 40, 40);

        buttonDelete.addActionListener(this);
        buttonDelete.setActionCommand("Delete");
   	
        buttonUp.addActionListener(this);
        buttonUp.setActionCommand("Up");
   	
        buttonDown.addActionListener(this);
        buttonDown.setActionCommand("Down");

        // Create border
        CompoundBorder listBorder = new CompoundBorder(
                new EmptyBorder(10, 10, 10, 10),
                new TitledBorder(new EtchedBorder(),
                    "Save Preferences"));
      
        JLabel labelList = new JLabel("Use drag&drop to select items to save");

        labelList.setBounds(25, 25, 300, 30);
        mSavePanel.add(labelList);

        mSavePanel.add(buttonDelete);
        mSavePanel.add(buttonUp);
        mSavePanel.add(buttonDown);

        mSavePanel.setBorder(listBorder);
   	  
        // Second half of pane
        JLabel labelRadio = new JLabel("Select separation character");

        labelRadio.setBounds(25, 300, 300, 30);
        mSavePanel.add(labelRadio);
	  
        radioTab = new JRadioButton("Tab");
        radioOtherCharacter = new JRadioButton("Other character:");
        ButtonGroup bgSepChar = new ButtonGroup();

        bgSepChar.add(radioTab);
        bgSepChar.add(radioOtherCharacter);
        radioTab.setBounds(25, 330, 100, 25); 
        radioOtherCharacter.setBounds(25, 352, 120, 25); 
        mSavePanel.add(radioTab);
        mSavePanel.add(radioOtherCharacter);
	  
        // Now set the item listener for both radiobuttons
        radioTab.addItemListener(this);
        radioOtherCharacter.addItemListener(this);
   	
        textSepChar = new JTagTableTextField(1, false);
        textSepChar.setBounds(150, 352, 15, 20);
        mSavePanel.add(textSepChar);
	  
        // END of SAVE pane
   
        // --- Database panel
        mDatabasePanel = new JTagDatabasePrefs();
        mDatabasePanel.setSize(50, 50);
        mTabbedPane.addTab("Database", new ImageIcon("images/savedb.gif"), mDatabasePanel);
        // Create border
        CompoundBorder dbBorder = new CompoundBorder(
                new EmptyBorder(10, 10, 10, 10),
                new TitledBorder(new EtchedBorder(),
                    "Database Preferences"));

        mDatabasePanel.setBorder(dbBorder);

        // --- End of database panel
   	
        // --- Sync panel
        mSyncPanel = new JTagSyncPrefs();
        mSyncPanel.setSize(50, 50);
        mTabbedPane.addTab("Sync", new ImageIcon("images/sync.gif"), mSyncPanel);
        // Create border
        CompoundBorder syncBorder = new CompoundBorder(
                new EmptyBorder(10, 10, 10, 10),
                new TitledBorder(new EtchedBorder(),
                    "Sync Preferences"));

        mSyncPanel.setBorder(syncBorder);

        // --- End of sync panel

		  
        //---- PLAY panel	  
        mPlayPanel = new JPanel();
        mPlayPanel.setLayout(null);
        mTabbedPane.addTab("Play", new ImageIcon("images/play.gif"), mPlayPanel);
  
        // Create border
        CompoundBorder playBorder = new CompoundBorder(
                new EmptyBorder(10, 10, 10, 10),
                new TitledBorder(new EtchedBorder(),
                    "Play Preferences"));

        mPlayPanel.setBorder(playBorder);
   	
        JLabel labelPlay = new JLabel("Select location of MP3 player");

        labelPlay.setBounds(25, 50, 300, 30);
        mPlayPanel.add(labelPlay);
  
        textMp3Player = new JTextField();
        textMp3Player.setBounds(25, 80, 200, 20);
        mPlayPanel.add(textMp3Player);
  
        JButton buttonPlay = new JButton("Browse...", new ImageIcon("images/open.gif"));

        buttonPlay.setBounds(25, 100, 100, 30);
        buttonPlay.setMargin(new Insets(0, 0, 0, 0));
  
        buttonPlay.addActionListener(this); 	
        buttonPlay.setActionCommand("BrowsePlay"); 	
   	
        mPlayPanel.add(buttonPlay);

        // END of PLAY pane
   	
   	
        // The buttons
        JPanel panelButtons = new JPanel();
   
        buttonCancel = new JButton("Cancel");
        buttonOk = new JButton("  Ok  ");
   
        panelButtons.add(buttonOk);
        panelButtons.add(buttonCancel);
   
        contentPane.add("South", panelButtons);
   	     	  
        // Add the tabbed pane
        contentPane.add("Center", mTabbedPane);
   	
    }
    
    public void actionPerformed(ActionEvent e) {
        //DELETE
        if (e.getActionCommand().equals("Delete")) {
            int index = list2.getSelectedIndex();

            if (index != -1) {
                list2.listData.remove(index);
                list2.setListData(list2.listData);
            }
        } 
        //UP
        if (e.getActionCommand().equals("Up")) {
            int index = list2.getSelectedIndex();

            if (index != -1 && index != 0) {
                String item = new String((String) list2.getSelectedValue());

                list2.listData.remove(index);
                list2.listData.add(index - 1, item);
                list2.setListData(list2.listData);
                list2.setSelectedIndex(index - 1);
            }
        } 
        //DOWN
        if (e.getActionCommand().equals("Down")) {
            int index = list2.getSelectedIndex();

            if (index != -1 && index != (list2.listData.size() - 1)) {
                String item = new String((String) list2.getSelectedValue());

                list2.listData.remove(index);
                list2.listData.add(index + 1, item);
                list2.setListData(list2.listData);
                list2.setSelectedIndex(index + 1);
            }
        }
        // BROWSEPLAY
        if (e.getActionCommand().equals("BrowsePlay")) {
            JFileChooser mp3Chooser = new JFileChooser();

            mp3Chooser.setDialogTitle("Choose MP player");
   
            int returnValue = mp3Chooser.showOpenDialog(this);
   
            if (returnValue == JFileChooser.CANCEL_OPTION)
                return;
   
            File inputDir = mp3Chooser.getSelectedFile();
   
            if (inputDir == null)
                return;
	    	
            textMp3Player.setText(inputDir.toString());
  
        }
       
    } // End of actionlistener
	
    // Item event	
    public void itemStateChanged(ItemEvent e) {
        if (e.getSource() == radioTab && e.getStateChange() == e.SELECTED) {
            textSepChar.setEnabled(false);
        }
        if (e.getSource() == radioOtherCharacter && e.getStateChange() == e.SELECTED) {
            textSepChar.setEnabled(true);
        }

    } // End of item event	
	
    public Vector getResultListVector() {
        return list2.listData;
    }
}
