package org.jtag.dnd;

import java.awt.*;
import java.awt.event.*;
import java.awt.dnd.*;
import java.awt.datatransfer.*;
import javax.swing.*;


public class SourceList extends JList implements 
        DragSourceListener, DragGestureListener {
    private DragSource mSource;
   
    public SourceList() {
        super();

        // Create our mouse listener and make it listen to 
        // this component's mouse and mouse motion events.
        /*   
         SourceMouseListener sma = new SourceMouseListener();
         addMouseListener( sma );
         addMouseMotionListener( sma );
         */ 
        mSource = new DragSource();
        mSource.createDefaultDragGestureRecognizer(this, DnDConstants.ACTION_COPY_OR_MOVE,
            this);
   
    }
	
    public void dragGestureRecognized(DragGestureEvent e) {
        //String selectedItem = getSelectedItem();
        String selectedItem = (String) getSelectedValue();

        mSource.startDrag(e, DragSource.DefaultCopyDrop, new StringSelection(selectedItem), this);
    }
	
    // NEW
    public void dropActionChanged(DragSourceDragEvent e) {}

    // This is called when the item has been dropped on a 
    // DropTarget and the target has called the 
    // TargetContext's dropComplete() method.
   
    public void dragDropEnd(DragSourceDropEvent e) {}

    // This is called when the drag cursor enters a 
    // DropTarget where the item can be dropped.
   
    public void dragEnter(DragSourceDragEvent e) {}

    // This is called when the drag cursor exits a 
    // DropTarget where the item can be dropped.
   
    public void dragExit(DragSourceEvent e) {}
   
    // This is called when the drag events change.

    public void dragGestureChanged(DragSourceDragEvent e) {}

    // This is called when the drag cursor is being dragged 
    // over a DropTarget where the item can be dropped.
   
    public void dragOver(DragSourceDragEvent e) {}

}
