package org.jtag.io;

import java.io.*;
import java.util.*;

import org.jtag.mp3.*;


public class readPreferences {
    BufferedReader fileToRead;
	
    public String mp3Player, sepCharacter, dbUser, dbURL, dbDriver;
    public long autoSave = 0;
	
    public Vector outputList = new Vector();
	
    public readPreferences(String file) {
        String line;
        Hashtable hash = mp3ListEntries.returnHashtable();
		
        File fo = new File(file);
		
        if (!fo.exists())
            return;
		
        try {
            fileToRead = new BufferedReader(new FileReader(file));
		 
            while ((line = fileToRead.readLine()) != null) {
                StringTokenizer st = new StringTokenizer(line, "=");

                if (st.countTokens() < 2)
                    continue;
		 	
                if (line.startsWith("#"))
                    continue;
		 	
                String parameter = st.nextToken().trim();
		 	
                if (parameter.equals("Mp3Player")) {
                    String token = st.nextToken().trim();
		 	 	
                    if (token.equals("NULL"))
                        continue;
                    else
                        mp3Player = token;
                }
		 	
                if (parameter.equals("SepCharacter")) {
                    String token = st.nextToken().trim();
		 	 	
                    if (token.equals("TAB")) {
                        sepCharacter = token;
                    } else {
                        // Use first character as separator
                        sepCharacter = token.substring(0, 1);
                    }
                }
		 	
                if (parameter.equals("OutputList")) {
                    StringTokenizer st2 = new StringTokenizer(st.nextToken().trim(), ",");

                    while (st2.hasMoreTokens()) {
                        String token = st2.nextToken().trim();
		 	 	 	
                        if (hash.containsKey(token))
                            outputList.add(token);
                    }
                }
		 	
                // Database Values
                if (parameter.equals("DbUser")) {
                    String token = st.nextToken().trim();
		 	 	
                    if (token.equals("NULL"))
                        continue;
                    else
                        dbUser = token;
                }
		 	
                if (parameter.equals("DbURL")) {
                    String token = st.nextToken().trim();
		 	 	
                    if (token.equals("NULL"))
                        continue;
                    else
                        dbURL = token;
                }
		 	
                if (parameter.equals("DbDriver")) {
                    String token = st.nextToken().trim();
		 	 	
                    if (token.equals("NULL"))
                        continue;
                    else
                        dbDriver = token;
                }

                if (parameter.equals("AutoSave")) {
                    String token = st.nextToken().trim();
		 	 	
                    if (token.equals("NULL"))
                        continue;
                    else
                        autoSave = new Long(token).longValue();
		 		
                }

            }
		 
        } catch (Exception e) {
            System.err.println("Exception: " + e);
        }
    }
	
} // End of class
