package org.jtag.table;

import java.awt.*;
import java.awt.event.*;
import java.io.*;
import javax.swing.*;


public class JTagTableTextField extends JTextField {
    int mNumberOfChars;
    boolean mNumbersOnly;
		
    public JTagTableTextField(int number, boolean bNumbers) {
        super();	
        mNumberOfChars = number;
        mNumbersOnly = bNumbers;
    }
  
    public void setText(String strText) {
        if (strText != null) {
            if ((mNumberOfChars > 0) && (strText.length() > mNumberOfChars)) {
                strText = strText.substring(0, mNumberOfChars);
            }
        }
        super.setText(strText);
    }
  
    public void replaceSelection(String strText) {
        if (mNumberOfChars > 0) {
            // Check if mNumbersOnly is set
            if (mNumbersOnly && strText != null) {
                char strArray[] = strText.toCharArray();

                if (!(strArray[0] >= '0' && strArray[0] <= '9')) {
                    getToolkit().beep();
                    return;
                }
            }
   	  
            int nLength = 0;

            if (strText != null) {
                nLength += strText.length();
            }
            if (getText() != null) {
                nLength += getText().length();
            }
            if (getSelectedText() != null) {
                nLength -= getSelectedText().length();
            }
    
            if (nLength > mNumberOfChars) {
                getToolkit().beep();
                return;
            }
        }
   
        super.replaceSelection(strText);
    }
} 
 // End of class
 
